<?php

/**
 * @file
 */

/**
 * Implements hook_drush_command().
 */
function drush_useful_drush_command() {

  $commands['useful-developer-install'] = [
    'description' => 'Install all the important development modules such as Devel, Admin Toolbar etc.',
    'aliases' => ['idev'],
  ];

  $commands['useful-developer-uninstall'] = [
    'description' => 'Uninstall development modules such as Devel, Admin Toolbar etc.',
    'aliases' => ['udev'],
  ];

  $commands['useful-seo-install'] = [
    'description' => 'Install all the modules related to SEO of the website.',
    'aliases' => ['iseo'],
  ];

  $commands['useful-seo-uninstall'] = [
    'description' => 'Uninstall all the modules related to SEO of the website.',
    'aliases' => ['useo'],
  ];

  $commands['useful-optimize-install'] = [
    'description' => 'Install optimization modules such as Redis, Advance aggregation, Fast 404 etc.',
    'aliases' => ['iopt'],
  ];

  $commands['useful-optimize-uninstall'] = [
    'description' => 'Uninstall optimization modules such as Redis, Advance aggregation, Fast 404 etc.',
    'aliases' => ['uopt'],
  ];

  $commands['useful-migration-install'] = [
    'description' => 'Install Migration Modules such as migrate ,backup_migrate, migrate_plus  etc.',
    'aliases' => ['imig'],
  ];

  $commands['useful-migration-uninstall'] = [
    'description' => 'uninstall Migration Modules such as migrate ,backup_migrate, migrate_plus  etc.',
    'aliases' => ['umig'],
  ];


  $commands['useful-decoupled-install'] = [
    'description' => 'Install Decoupled Modules such as   RestAPI,drupalgap',
    'aliases' => ['idcoup'],
  ];

  $commands['useful-decoupled-uninstall'] = [
    'description' => 'Uninstall Decoupled Modules such as  RestAPI, drupalgap',
    'aliases' => ['udcoup'],
  ];

  $commands['useful-security-install'] = [
    'description' => 'Install Security related modules such as aptcha, recaptcha,paranoia,tfa,password_strength',
    'aliases' => ['isec'],
  ];

  $commands['useful-security-uninstall'] = [
    'description' => 'Uninstall Security related modules such as aptcha, recaptcha,paranoia,tfa,password_strength',
    'aliases' => ['usec'],
  ];

  $commands['useful-search-install'] = [
    'description' => 'Install Search enhancing modules such as Search API, Search API DB, Facets etc.',
    'aliases' => ['isrch'],
  ];

  $commands['useful-search-uninstall'] = [
    'description' => 'Uninstall search modules such as Search API, Search API DB, Facets etc.',
    'aliases' => ['usrch'],
  ];

  $commands['useful-social-install'] = [
    'description' => 'Install social sharing modules like  AddToAny , socailmedia etc',
    'aliases' => ['isoc'],
  ];

  $commands['useful-social-uninstall'] = [
    'description' => 'Uninstall social sharing modules like  AddToAny , social medialetc',
    'aliases' => ['usoc'],
  ];

  $commands['useful-advertise-install'] = [
    'description' => 'Install  modules  like  google_adsense, dfp, mailchip, simpleads etc.',
    'aliases' => ['iadv'],
  ];

  $commands['useful-advertise-uninstall'] = [
    'description' => 'Uninstall  modules  like  google_adsense, dfp, mailchip, simpleads etc.',
    'aliases' => ['uadv'],
  ];

  return $commands;
}

/**
 * Drush command logic for command useful-developer-install.
 */
function drush_drush_useful_useful_developer_install() {
  drush_invoke('pm-enable', ['devel', 'admin_menu']);
  drush_invoke('pm-enable', [ 'devel_generate', 'kint','module_filter']);
}

/**
 * Drush command logic for command useful-developer-uninstall.
 */
function drush_drush_useful_useful_developer_uninstall() {
  drush_invoke('pm-disable', ['devel_generate', 'kint','module_filter','views_ui']);
  drush_invoke('pm-disable', ['devel', 'admin_menu']);
}

/**
 * Drush command logic for useful-seo-install.
 */
function drush_drush_useful_useful_seo_install() {
  drush_invoke('pm-enable', ['metatag', 'pathauto', 'xmlsitemap', 'google_analytics', 'redirect', 'schema_metatag', 'yoast_seo']);
  drush_invoke('pm-enable', ['metatag_views']);
}

/**
 * Drush command logic for useful-seo-install.
 */
function drush_drush_useful_useful_seo_uninstall() {
  drush_invoke('pm-disable', ['metatag_views']);
  drush_invoke('pm-disable', ['metatag', 'pathauto', 'xmlsitemap', 'google_analytics', 'redirect', 'schema_metatag', 'yoast_seo']);
}

/**
 * Drush command logic for useful-optimization-install.
 */
function drush_drush_useful_useful_optimize_install() {
  drush_invoke('pm-enable', ['advagg', 'redis', 'fast_404']);
  drush_invoke('pm-enable', ['advagg_old_ie_compatibility', 'advagg_css_minify', ' advagg_cdn', 'advagg_bundler', 'advagg_mod', 'advagg_ext_minify', 'advagg_validator', ' advagg_js_minify']);
}

/**
 * Drush commands logic for useful-optimization-uninstall.
 */
function drush_drush_useful_useful_optimize_uninstall() {
  drush_invoke('pm-disable', ['advagg_old_ie_compatibility', 'advagg_css_minify', ' advagg_cdn', 'advagg_bundler', 'advagg_mod', 'advagg_ext_minify', 'advagg_validator', ' advagg_js_minify']);
  drush_invoke('pm-disable', ['advagg', 'redis', 'fast_404']);
}


/**
 * Drush command logic for useful-migrate-install.
 */
function drush_drush_useful_useful_migration_install() {
  drush_invoke('pm-enable', ['backup_migrate', 'migrate','migrate_extras']);
  drush_invoke('pm-enable', ['migrate_ui', ' migrate_extras_pathauto', 'migrate_extras_profile2','migrate_extras_media', 'migrate_extras']);

}

/**
 * Drush commands logic for useful-migrate-uninstall.
 */
function drush_drush_useful_useful_migration_uninstall() {
    drush_invoke('pm-disable',  ['migrate_ui', ' migrate_extras_pathauto', 'migrate_extras_profile2','migrate_extras_media', 'migrate_extras']);
    drush_invoke('pm-disable', ['backup_migrate', 'migrate']);

}

/**
 * Drush command logic for useful-decoupled-install.
 */
function drush_drush_useful_useful_decoupled_install() {
  drush_invoke('pm-enable', ['restful','drupalgap']);
  drush_invoke('pm-enable', ['drupalgap_user_registrationpassword',' drupalgap_email_registration','drupalgap_staticmap',' drupalgap_logintoboggan', 'drupalgap_og', 'drupalgap_webform', 'drupalgap_entityreference', 'drupalgap_flag', 'drupalgap_rate',' drupalgap_date', 'drupalgap_autoassignrole']);

}

/**
 * Drush commands logic for useful-decoupled-uninstall.
 */
function drush_drush_useful_useful_decoupled_uninstall() {
     drush_invoke('pm-disable', ['drupalgap_user_registrationpassword',' drupalgap_email_registration','drupalgap_staticmap',' drupalgap_logintoboggan', 'drupalgap_og', 'drupalgap_webform', 'drupalgap_entityreference', 'drupalgap_flag', 'drupalgap_rate',' drupalgap_date', 'drupalgap_autoassignrole']);
     drush_invoke('pm-disable',['restful','drupalgap']);

}

/**
 * Drush command logic for useful-security-install.
 */
function drush_drush_useful_useful_security_install() {
  drush_invoke('pm-enable', ['captcha', 'recaptcha', 'paranoia', 'tfa', 'password_strength']);
  drush_invoke('pm-enable', ['image_captcha']);
}

/**
 * Drush commands logic for useful-security-uninstall.
 */
function drush_drush_useful_useful_security_uninstall() {
  drush_invoke('pm-disable', ['image_captcha']);
  drush_invoke('pm-disable', ['captcha', 'recaptcha', 'paranoia', 'tfa', 'password_strength']);
}


/**
 * Drush command logic for useful-search-install.
 */
function drush_drush_useful_useful_search_install() {
  drush_invoke('pm-enable', ['search_api', 'facetapi','module_filter']);
  drush_invoke('pm-enable', ['search_api_glossary', 'search_api_sorts']);
  drush_invoke('pm-enable', ['search_api_views_taxonomy', 'search_api_db_defaults', 'search_api_db']);
}

/**
 * Drush commands logic for useful-search-uninstall.
 */
function drush_drush_useful_useful_search_uninstall() {
  drush_invoke('pm-disable', ['search_api_views_taxonomy', 'search_api_db_defaults', 'search_api_db']);
  drush_invoke('pm-disable', ['search_api_glossary', 'search_api_sorts']);
  drush_invoke('pm-disable', ['search_api', 'facetapi','module_filter']);
}


/**
 * Drush command logic for useful-social-install.
 */
function drush_drush_useful_useful_social_install() {
  drush_invoke('pm-enable', ['addtoany', 'socialmedia']);
}

/**
 * Drush commands logic for useful-social-uninstall.
 */
function drush_drush_useful_useful_social_uninstall() {
  drush_invoke('pm-disable', ['addtoany', 'socialmedia']);
}

/**
 * Drush command logic for useful-advertise-install.
 */
function drush_drush_useful_useful_advertise_install() {
  drush_invoke('pm-enable',['mailchimp','adsense','dfp','simpleads']);
}

/**
 * Drush commands logic for useful-advertise-uninstall.
 */
function drush_drush_useful_useful_advertise_uninstall() {
  drush_invoke('pm-disable' , ['mailchimp','adsense','dfp','simpleads']);
}
